! adjacent_faces.f90
! Determine facets adjacent to the surface nodes.
! Miroslav Broz (miroslav.broz@email.cz), Aug 1st 2007

module adjacent_faces_module

contains

subroutine adjacent_faces(faces, surface_idx, adjacent_cnt, adjacent_idx)

implicit none

integer, dimension(:,:) :: faces
integer, dimension(:) :: surface_idx
integer, dimension(:,:), pointer :: adjacent_idx
integer, dimension(:), pointer :: adjacent_cnt

integer :: i, j, k

allocate(adjacent_cnt(size(surface_idx)))

! count the maximum # of adjacent facets
adjacent_cnt = 0
do i = 1, size(adjacent_cnt)
  do j = 1, size(faces(:,1))
    do k = 1, 3
      if (faces(j,k).eq.surface_idx(i)) then
        adjacent_cnt(i) = adjacent_cnt(i) + 1
      endif
    enddo
  enddo
enddo

allocate(adjacent_idx(size(surface_idx), maxval(adjacent_cnt)))

! list the adjacent faces
adjacent_cnt = 0
adjacent_idx = 0
do i = 1, size(surface_idx)
  do j = 1, size(faces(:,1))
    do k = 1, 3
      if (faces(j,k).eq.surface_idx(i)) then
        adjacent_cnt(i) = adjacent_cnt(i) + 1
        adjacent_idx(i, adjacent_cnt(i)) = j
      endif
    enddo
  enddo
enddo

return

end subroutine adjacent_faces

end module adjacent_faces_module


