! const.f90
! Physical constants module.
! Miroslav Broz (miroslav.broz@email.cz), May 6th 2007

module const

implicit none

! pi
double precision, parameter :: pi = 3.1415926535d0

! Boltzmann constant [J.K^(-4).m^(-2).s^(-1)]
double precision, parameter :: sigma = 5.66962d-8

! speed of light [m.s^(-1)]
double precision, parameter :: cv = 299792458.0d0

! solar constant [W.m^(-2)]
double precision, parameter :: S0 = 1371.d0

! Gauss constant
double precision, parameter :: k_gauss = 0.01720209895d0

! astronomical unit [m]
double precision, parameter :: AU = 149597870.d3

! day [sec]
double precision, parameter :: day = 86400.d0

end module const


