! ftcs_step4.f
! Forward Time Centered Space for tetrahedral mesh.
! Miroslav Broz (miroslav.broz@email.cz), Aug 2nd 2007

module ftcs_step4_module

contains

subroutine ftcs_step4(u_n, u_n_interp, dt, dx, D, surface_idx, interior_idx, u_n_plus_1)

implicit none

double precision, dimension(:) :: u_n, u_n_plus_1
double precision, dimension(:,:) :: u_n_interp
double precision :: dt, dx, D
integer, dimension(:) :: surface_idx, interior_idx

integer :: i,j
double precision :: koef

! boundary is now simple...

surface_nodes: do j = 1, size(surface_idx)      ! surface nodes index
  i = surface_idx(j)                            ! all nodes index
  u_n_plus_1(i) = u_n(i)
enddo surface_nodes

! interior is a bit harder...

koef = dt * D / dx**2
interior_nodes: do j = 1, size(interior_idx)    ! interior nodes index 
  i = interior_idx(j)                           ! all nodes index
  u_n_plus_1(i) = u_n(i) + koef * ( &
    + u_n_interp(j,1) - 2*u_n(i) + u_n_interp(j,2) &    ! d^2u/dx^2
    + u_n_interp(j,3) - 2*u_n(i) + u_n_interp(j,4) &    ! d^2u/dy^2
    + u_n_interp(j,5) - 2*u_n(i) + u_n_interp(j,6) &    ! d^2u/dz^2
  )
enddo interior_nodes

return

end subroutine ftcs_step4

end module ftcs_step4_module


