! inside_tetrahedron.f90
! Point-inside-tetrahedron test.
! http://www.gvu.gatech.edu/~jarek/courses/6491/L06/06aVectors6491.ppt
! Miroslav Broz (miroslav.broz@email.cz), Aug 1st 2007

module inside_tetrahedron_module

contains

logical function inside_tetrahedron(v, x)

implicit none

double precision, dimension(:,:) :: v
double precision, dimension(:) :: x

logical, dimension(5) :: s

inside_tetrahedron = .FALSE.

s(1) = s_test(v(1,:), v(2,:), v(3,:), v(4,:))
s(2) = s_test(x, v(2,:), v(3,:), v(4,:))
if (s(2).neqv.s(1)) return

s(3) = s_test(v(1,:), x, v(3,:), v(4,:))
if (s(3).neqv.s(2)) return

s(4) = s_test(v(1,:), v(2,:), x, v(4,:))
if (s(4).neqv.s(3)) return

s(5) = s_test(v(1,:), v(2,:), v(3,:), x)
if (s(5).neqv.s(4)) return

inside_tetrahedron = .TRUE.

return

end function inside_tetrahedron

!=======================================================================

logical function s_test(a,b,c,d)

use vector_product_module

implicit none

double precision, dimension(:) :: a,b,c,d

integer :: i
double precision, dimension(4) :: da,db,dc,v

da = d-a
db = d-b
dc = d-c
call vector_product(db, dc, v)
if (dot_product(da, v).gt.0.d0) then
  s_test = .TRUE.
else
  s_test = .FALSE.
endif

return

end function s_test

end module inside_tetrahedron_module


