! insolation_node.f90
! Insolation of nodes calculated from insolations of adjacent facets.
! Miroslav Broz (miroslav.broz@email.cz), Aug 7th 2007

module insolation_node_module

contains

double precision function insolation_node(E, areas, cnt, idx)

double precision, dimension(:) :: E, areas
integer :: cnt
integer, dimension(:) :: idx

integer :: i
double precision :: E_mean, area

E_mean = 0.d0
area = 0.d0
do i = 1, cnt
  E_mean = E_mean + E(idx(i)) * areas(idx(i))
  area = area + areas(idx(i))
enddo
E_mean = E_mean / area

insolation_node = E_mean

return

end function insolation_node

end module insolation_node_module


