! interp_tetrahedron.f90
! Tri-linear interpolation in a tetrahedron.
! Miroslav Broz (miroslav.broz@email.cz), Aug 8th 2007

module interp_tetrahedron_module

contains

double precision function interp_tetrahedron(vertices, values, x)

use gem_module

implicit none

double precision, dimension(4,3) :: vertices
double precision, dimension(4) :: values
double precision, dimension(3) :: x

double precision, dimension(4,4) :: a
double precision, dimension(4) :: b
double precision :: u
integer :: i,j
logical :: sing

a(1,:) = vertices(:,1)
a(2,:) = vertices(:,2)
a(3,:) = vertices(:,3)
a(4,:) = 1.d0
b = values

call gem(a,b,sing)

if (.not.sing) then
  u = (b(1)*x(1) + b(2)*x(2) + b(3)*x(3) + b(4))
else
  write(*,'(a)') '# Warning: singular matrix in interp_tetrahedron/gem.'
  u = values(1)
endif

interp_tetrahedron = u
return

end function interp_tetrahedron

end module interp_tetrahedron_module


