! normalize.f90
! Normalize an N-dimensional vector.
! Miroslav Broz (miroslav.broz@email.cz), Aug 6th 2007

module normalize_module

contains

subroutine normalize(x)

implicit none

double precision, dimension(:) :: x

integer :: i
double precision :: norm

norm = 0.d0
do i = 1, size(x)
  norm = norm + x(i)*x(i)
enddo
norm = sqrt(norm)

if (abs(norm).gt.tiny(norm)) then
  norm = 1.d0/norm
  x = x*norm
else
  write(*,'(a)') '# Warning: zero vector in normalize'
endif

return

end subroutine normalize

end module normalize_module


