! normals_nodes.f90
! Calculate normals at all nodes (as an average of adjacent facets normals)
! Miroslav Broz (miroslav.broz@email.cz), Aug 1st 2007

module normals_nodes_module

contains

subroutine normals_nodes(normals_faces, adjacent_cnt, adjacent_idx, normals)

implicit none

double precision, dimension(:,:) :: normals_faces, normals
integer, dimension(:) :: adjacent_cnt
integer, dimension(:,:) :: adjacent_idx

integer :: i, j

do i = 1, size(normals(:,1))
  normals(i,:) = 0.d0
  do j = 1, adjacent_cnt(i)
    normals(i,:) = normals(i,:) + normals_faces(adjacent_idx(i,j),:)
  enddo
  normals(i,:) = normals(i,:) / adjacent_cnt(i)
enddo

return

end subroutine normals_nodes

end module normals_nodes_module


