! rotate_around_axis.f90
! Rotate a vector x around the axis v by the angle phi.
! Miroslav Broz (miroslav.broz@email.cz), Jul 31st 2007

module rotate_around_axis_module

contains

subroutine rotate_around_axis(v,phi,x,y)

implicit none

double precision :: v(3), phi, x(3), y(3)
double precision :: c,s

s = sin(phi)
c = cos(phi)

y(1) = x(1) * (c + (1-c)*v(1)**2)        + x(2) * ((1-c)*v(1)*v(2) - s*v(3)) + x(3) * ((1-c)*v(1)*v(3) + s*v(2))
y(2) = x(1) * ((1-c)*v(2)*v(1) + s*v(3)) + x(2) * (c + (1-c)*v(2)**2)        + x(3) * ((1-c)*v(2)*v(3) - s*v(1))
y(3) = x(1) * ((1-c)*v(3)*v(1) - s*v(2)) + x(2) * ((1-c)*v(3)*v(2) + s*v(1)) + x(3) * (c + (1-c)*v(3)**2)

return

end subroutine rotate_around_axis

end module rotate_around_axis_module


