! surface_interior.f90
! Distinguish surface and interior nodes.
! Miroslav Broz (miroslav.broz@email.cz), Aug 1st 2007

module surface_interior_module

contains

subroutine surface_interior(faces, nnodes, surface_idx, interior_idx)

implicit none

integer, dimension(:,:) :: faces
integer :: nnodes
integer, dimension(:), pointer :: surface_idx, interior_idx

integer, dimension(:), allocatable :: nodes_s_or_i_idx
integer :: i,j,k, nsurface_idx, ninterior_idx

allocate(nodes_s_or_i_idx(nnodes))
nodes_s_or_i_idx = 0
do i = 1, size(faces(:,1))
  do j = 1, size(faces(1,:))
    nodes_s_or_i_idx(faces(i,j)) = nodes_s_or_i_idx(faces(i,j)) + 1
  enddo
enddo
j = 0
k = 0
do i = 1, nnodes
  if ((nodes_s_or_i_idx(i)).gt.0) then
    j = j + 1
  else
    k = k + 1
  endif
enddo
nsurface_idx = j
ninterior_idx = k

allocate(surface_idx(nsurface_idx))
allocate(interior_idx(ninterior_idx))
j = 0
k = 0
do i = 1, nnodes
  if ((nodes_s_or_i_idx(i)).gt.0) then
    j = j + 1
    surface_idx(j) = i
  else
    k = k + 1
    interior_idx(k) = i
  endif
enddo

deallocate(nodes_s_or_i_idx)

return

end subroutine surface_interior

end module surface_interior_module


